diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/internet/model/ipv6-interface-address.h ns-3.44/src/internet/model/ipv6-interface-address.h
--- ns-3.43/src/internet/model/ipv6-interface-address.h	2024-10-09 16:41:09.888656000 -0700
+++ ns-3.44/src/internet/model/ipv6-interface-address.h	2025-03-09 16:55:49.399371100 -0700
@@ -17,17 +17,17 @@
 {
 
 /**
- * \ingroup address
- * \ingroup ipv6
+ * @ingroup address
+ * @ingroup ipv6
  *
- * \brief IPv6 address associated with an interface.
+ * @brief IPv6 address associated with an interface.
  */
 class Ipv6InterfaceAddress
 {
   public:
     /**
-     * \enum State_e
-     * \brief State of an address associated with an interface.
+     * @enum State_e
+     * @brief State of an address associated with an interface.
      */
     enum State_e
     {
@@ -42,8 +42,8 @@
     };
 
     /**
-     * \enum Scope_e
-     * \brief Address scope.
+     * @enum Scope_e
+     * @brief Address scope.
      */
     enum Scope_e
     {
@@ -53,184 +53,184 @@
     };
 
     /**
-     * \brief Default constructor.
+     * @brief Default constructor.
      */
     Ipv6InterfaceAddress();
 
     /**
-     * \brief Constructor. Prefix is 64 by default.
-     * \param address the IPv6 address to set
+     * @brief Constructor. Prefix is 64 by default.
+     * @param address the IPv6 address to set
      */
     Ipv6InterfaceAddress(Ipv6Address address);
 
     /**
-     * \brief Constructor.
-     * \param address IPv6 address to set
-     * \param prefix IPv6 prefix
+     * @brief Constructor.
+     * @param address IPv6 address to set
+     * @param prefix IPv6 prefix
      */
     Ipv6InterfaceAddress(Ipv6Address address, Ipv6Prefix prefix);
 
     /**
-     * \brief Constructor.
-     * \param address IPv6 address to set
-     * \param prefix IPv6 prefix
-     * \param onLink on-link property
+     * @brief Constructor.
+     * @param address IPv6 address to set
+     * @param prefix IPv6 prefix
+     * @param onLink on-link property
      */
     Ipv6InterfaceAddress(Ipv6Address address, Ipv6Prefix prefix, bool onLink);
 
     /**
-     * \brief Copy constructor.
-     * \param o object to copy
+     * @brief Copy constructor.
+     * @param o object to copy
      */
     Ipv6InterfaceAddress(const Ipv6InterfaceAddress& o);
 
     /**
-     * \brief Destructor.
+     * @brief Destructor.
      */
     ~Ipv6InterfaceAddress();
 
     /**
-     * \brief Set IPv6 address (and scope).
-     * \param address IPv6 address to set
+     * @brief Set IPv6 address (and scope).
+     * @param address IPv6 address to set
      */
     void SetAddress(Ipv6Address address);
 
     /**
-     * \brief Get the IPv6 address.
-     * \return IPv6 address
+     * @brief Get the IPv6 address.
+     * @return IPv6 address
      */
     Ipv6Address GetAddress() const;
 
     /**
-     * \brief Get the IPv6 prefix.
-     * \return IPv6 prefix
+     * @brief Get the IPv6 prefix.
+     * @return IPv6 prefix
      */
     Ipv6Prefix GetPrefix() const;
 
     /**
-     * \brief Set the state.
-     * \param state the state
+     * @brief Set the state.
+     * @param state the state
      */
     void SetState(Ipv6InterfaceAddress::State_e state);
 
     /**
-     * \brief Get the address state.
-     * \return address state
+     * @brief Get the address state.
+     * @return address state
      */
     Ipv6InterfaceAddress::State_e GetState() const;
 
     /**
-     * \brief Set the scope.
-     * \param scope the scope of address
+     * @brief Set the scope.
+     * @param scope the scope of address
      */
     void SetScope(Ipv6InterfaceAddress::Scope_e scope);
 
     /**
-     * \brief Get address scope.
-     * \return scope
+     * @brief Get address scope.
+     * @return scope
      */
     Ipv6InterfaceAddress::Scope_e GetScope() const;
 
     /**
-     * \brief Checks if the address is in the same subnet.
-     * \param b the address to check
-     * \return true if the address is in the same subnet.
+     * @brief Checks if the address is in the same subnet.
+     * @param b the address to check
+     * @return true if the address is in the same subnet.
      */
     bool IsInSameSubnet(Ipv6Address b) const;
 
     /**
-     * \brief Set the latest DAD probe packet UID.
-     * \param uid packet uid
+     * @brief Set the latest DAD probe packet UID.
+     * @param uid packet uid
      */
     void SetNsDadUid(uint32_t uid);
 
     /**
-     * \brief Get the latest DAD probe packet UID.
-     * \return uid
+     * @brief Get the latest DAD probe packet UID.
+     * @return uid
      */
     uint32_t GetNsDadUid() const;
 
     /**
-     * \brief Get the on-link property.
-     * \param onLink the on-link property
+     * @brief Get the on-link property.
+     * @param onLink the on-link property
      */
     void SetOnLink(bool onLink);
 
     /**
-     * \brief Get the on-link property.
-     * \return on-link flag
+     * @brief Get the on-link property.
+     * @return on-link flag
      */
     bool GetOnLink() const;
 
 #if 0
   /**
-   * \brief Start the DAD timer.
-   * \param interface interface
+   * @brief Start the DAD timer.
+   * @param interface interface
    */
   void StartDadTimer (Ptr<Ipv6Interface> interface);
 
   /**
-   * \brief Stop the DAD timer.
+   * @brief Stop the DAD timer.
    */
   void StopDadTimer ();
 #endif
 
   private:
     /**
-     * \brief The IPv6 address.
+     * @brief The IPv6 address.
      */
     Ipv6Address m_address;
 
     /**
-     * \brief The IPv6 prefix.
+     * @brief The IPv6 prefix.
      */
     Ipv6Prefix m_prefix;
 
     /**
-     * \brief State of the address.
+     * @brief State of the address.
      */
     State_e m_state;
 
     /**
-     * \brief Scope of the address.
+     * @brief Scope of the address.
      */
     Scope_e m_scope;
 
     /**
-     * \brief The address belongs to an on-link network.
+     * @brief The address belongs to an on-link network.
      */
     bool m_onLink;
 
     /**
-     * \brief Equal to operator.
+     * @brief Equal to operator.
      *
-     * \param a the first operand
-     * \param b the first operand
-     * \returns true if the operands are equal
+     * @param a the first operand
+     * @param b the first operand
+     * @returns true if the operands are equal
      */
     friend bool operator==(const Ipv6InterfaceAddress& a, const Ipv6InterfaceAddress& b);
 
     /**
-     * \brief Not equal to operator.
+     * @brief Not equal to operator.
      *
-     * \param a the first operand
-     * \param b the first operand
-     * \returns true if the operands are not equal
+     * @param a the first operand
+     * @param b the first operand
+     * @returns true if the operands are not equal
      */
     friend bool operator!=(const Ipv6InterfaceAddress& a, const Ipv6InterfaceAddress& b);
 
     /**
-     * \brief Last DAD probe packet UID.
+     * @brief Last DAD probe packet UID.
      */
     uint32_t m_nsDadUid;
 };
 
 /**
- * \brief Stream insertion operator.
+ * @brief Stream insertion operator.
  *
- * \param os the reference to the output stream
- * \param addr the Ipv6InterfaceAddress
- * \returns the reference to the output stream
+ * @param os the reference to the output stream
+ * @param addr the Ipv6InterfaceAddress
+ * @returns the reference to the output stream
  */
 std::ostream& operator<<(std::ostream& os, const Ipv6InterfaceAddress& addr);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/internet/model/ipv6-interface.cc ns-3.44/src/internet/model/ipv6-interface.cc
--- ns-3.43/src/internet/model/ipv6-interface.cc	2024-10-09 16:41:09.888656000 -0700
+++ ns-3.44/src/internet/model/ipv6-interface.cc	2025-03-09 16:55:49.399371100 -0700
@@ -408,7 +408,7 @@
      * traffic control layer */
     if (DynamicCast<LoopbackNetDevice>(m_device))
     {
-        /** \todo additional checks needed here (such as whether multicast
+        /** @todo additional checks needed here (such as whether multicast
          * goes to loopback)?
          */
         p->AddHeader(hdr);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/internet/model/ipv6-interface.h ns-3.44/src/internet/model/ipv6-interface.h
--- ns-3.43/src/internet/model/ipv6-interface.h	2024-10-09 16:41:09.888656000 -0700
+++ ns-3.44/src/internet/model/ipv6-interface.h	2025-03-09 16:55:49.399371100 -0700
@@ -29,9 +29,9 @@
 class TrafficControlLayer;
 
 /**
- * \ingroup ipv6
+ * @ingroup ipv6
  *
- * \brief The IPv6 representation of a network interface.
+ * @brief The IPv6 representation of a network interface.
  *
  * By default IPv6 interfaces are created in the "down" state
  * with IP "fe80::1" and a /64 prefix. Before becoming usable,
@@ -42,18 +42,18 @@
 {
   public:
     /**
-     * \brief Get the type ID
-     * \return type ID
+     * @brief Get the type ID
+     * @return type ID
      */
     static TypeId GetTypeId();
 
     /**
-     * \brief Constructs an Ipv6Interface.
+     * @brief Constructs an Ipv6Interface.
      */
     Ipv6Interface();
 
     /**
-     * \brief Destructor.
+     * @brief Destructor.
      */
     ~Ipv6Interface() override;
 
@@ -62,206 +62,206 @@
     Ipv6Interface& operator=(const Ipv6Interface&) = delete;
 
     /**
-     * \brief Set node associated with interface.
-     * \param node node
+     * @brief Set node associated with interface.
+     * @param node node
      */
     void SetNode(Ptr<Node> node);
 
     /**
-     * \brief Set the NetDevice.
-     * \param device NetDevice
+     * @brief Set the NetDevice.
+     * @param device NetDevice
      */
     void SetDevice(Ptr<NetDevice> device);
 
     /**
-     * \brief Set the TrafficControlLayer.
-     * \param tc TrafficControlLayer object
+     * @brief Set the TrafficControlLayer.
+     * @param tc TrafficControlLayer object
      */
     void SetTrafficControl(Ptr<TrafficControlLayer> tc);
 
     /**
-     * \brief Get the NetDevice.
-     * \return the NetDevice associated with this interface
+     * @brief Get the NetDevice.
+     * @return the NetDevice associated with this interface
      */
     virtual Ptr<NetDevice> GetDevice() const;
 
     /**
-     * \brief Set the metric.
-     * \param metric configured routing metric (cost) of this interface
+     * @brief Set the metric.
+     * @param metric configured routing metric (cost) of this interface
      */
     void SetMetric(uint16_t metric);
 
     /**
-     * \brief Get the metric
-     * \return the metric
+     * @brief Get the metric
+     * @return the metric
      */
     uint16_t GetMetric() const;
 
     /**
-     * \brief Is the interface UP ?
-     * \return true if interface is enabled, false otherwise.
+     * @brief Is the interface UP ?
+     * @return true if interface is enabled, false otherwise.
      */
     bool IsUp() const;
 
     /**
-     * \brief Is the interface DOWN ?
-     * \return true if interface is disabled, false otherwise.
+     * @brief Is the interface DOWN ?
+     * @return true if interface is disabled, false otherwise.
      */
     bool IsDown() const;
 
     /**
-     * \brief Enable this interface.
+     * @brief Enable this interface.
      */
     void SetUp();
 
     /**
-     * \brief Disable this interface.
+     * @brief Disable this interface.
      */
     void SetDown();
 
     /**
-     * \brief If the interface allows forwarding packets.
-     * \return true if forwarding is enabled, false otherwise
+     * @brief If the interface allows forwarding packets.
+     * @return true if forwarding is enabled, false otherwise
      */
     bool IsForwarding() const;
 
     /**
-     * \brief Set forwarding enabled or not.
-     * \param forward forwarding state
+     * @brief Set forwarding enabled or not.
+     * @param forward forwarding state
      */
     void SetForwarding(bool forward);
 
     /**
-     * \brief Set the current hop limit.
-     * \param curHopLimit the value to set
+     * @brief Set the current hop limit.
+     * @param curHopLimit the value to set
      */
     void SetCurHopLimit(uint8_t curHopLimit);
 
     /**
-     * \brief Get the current hop limit value.
-     * \return current hop limit
+     * @brief Get the current hop limit value.
+     * @return current hop limit
      */
     uint8_t GetCurHopLimit() const;
 
     /**
-     * \brief Set the base reachable time.
-     * \param baseReachableTime the value to set
+     * @brief Set the base reachable time.
+     * @param baseReachableTime the value to set
      */
     void SetBaseReachableTime(uint16_t baseReachableTime);
 
     /**
-     * \brief Get the base reachable time.
-     * \return base reachable time
+     * @brief Get the base reachable time.
+     * @return base reachable time
      */
     uint16_t GetBaseReachableTime() const;
 
     /**
-     * \brief Set the reachable time.
-     * \param reachableTime value to set
+     * @brief Set the reachable time.
+     * @param reachableTime value to set
      */
     void SetReachableTime(uint16_t reachableTime);
 
     /**
-     * \brief Get the reachable time.
-     * \return reachable time
+     * @brief Get the reachable time.
+     * @return reachable time
      */
     uint16_t GetReachableTime() const;
 
     /**
-     * \brief Set the retransmission timer.
-     * \param retransTimer value to set
+     * @brief Set the retransmission timer.
+     * @param retransTimer value to set
      */
     void SetRetransTimer(uint16_t retransTimer);
 
     /**
-     * \brief Get the retransmission timer.
-     * \return retransmission timer
+     * @brief Get the retransmission timer.
+     * @return retransmission timer
      */
     uint16_t GetRetransTimer() const;
 
     /**
-     * \brief Send a packet through this interface.
-     * \param p packet to send
-     * \param hdr IPv6 header
-     * \param dest next hop address of packet.
+     * @brief Send a packet through this interface.
+     * @param p packet to send
+     * @param hdr IPv6 header
+     * @param dest next hop address of packet.
      *
-     * \note This method will eventually call the private SendTo
+     * @note This method will eventually call the private SendTo
      * method which must be implemented by subclasses.
      */
     void Send(Ptr<Packet> p, const Ipv6Header& hdr, Ipv6Address dest);
 
     /**
-     * \brief Add an IPv6 address.
-     * \param iface address to add
-     * \return true if address was added, false otherwise
+     * @brief Add an IPv6 address.
+     * @param iface address to add
+     * @return true if address was added, false otherwise
      */
     bool AddAddress(Ipv6InterfaceAddress iface);
 
     /**
-     * \brief Get link-local address from IPv6 interface.
-     * \return link-local Ipv6InterfaceAddress, assert if not found
+     * @brief Get link-local address from IPv6 interface.
+     * @return link-local Ipv6InterfaceAddress, assert if not found
      */
     Ipv6InterfaceAddress GetLinkLocalAddress() const;
 
     /**
-     * \brief Checks if the address is a Solicited Multicast address for this interface.
-     * \param address the address to check.
-     * \return true if it is a solicited multicast address.
+     * @brief Checks if the address is a Solicited Multicast address for this interface.
+     * @param address the address to check.
+     * @return true if it is a solicited multicast address.
      */
     bool IsSolicitedMulticastAddress(Ipv6Address address) const;
 
     /**
-     * \brief Get an address from IPv6 interface.
-     * \param index index
-     * \return Ipv6InterfaceAddress address whose index is i
+     * @brief Get an address from IPv6 interface.
+     * @param index index
+     * @return Ipv6InterfaceAddress address whose index is i
      */
     Ipv6InterfaceAddress GetAddress(uint32_t index) const;
 
     /**
-     * \brief Get an address which is in the same network prefix as destination.
-     * \param dst destination address
-     * \return Corresponding Ipv6InterfaceAddress or assert if not found
+     * @brief Get an address which is in the same network prefix as destination.
+     * @param dst destination address
+     * @return Corresponding Ipv6InterfaceAddress or assert if not found
      */
     Ipv6InterfaceAddress GetAddressMatchingDestination(Ipv6Address dst);
 
     /**
-     * \brief Get number of addresses on this IPv6 interface.
-     * \return number of address
+     * @brief Get number of addresses on this IPv6 interface.
+     * @return number of address
      */
     uint32_t GetNAddresses() const;
 
     /**
-     * \brief Remove an address from interface.
-     * \param index index to remove
-     * \return Ipv6InterfaceAddress address whose index is index
+     * @brief Remove an address from interface.
+     * @param index index to remove
+     * @return Ipv6InterfaceAddress address whose index is index
      */
     Ipv6InterfaceAddress RemoveAddress(uint32_t index);
 
     /**
-     * \brief Remove the given Ipv6 address from the interface.
-     * \param address The Ipv6 address to remove
-     * \returns The removed Ipv6 interface address
-     * \returns The null interface address if the interface did not contain the
+     * @brief Remove the given Ipv6 address from the interface.
+     * @param address The Ipv6 address to remove
+     * @returns The removed Ipv6 interface address
+     * @returns The null interface address if the interface did not contain the
      * address or if loopback address was passed as argument
      */
     Ipv6InterfaceAddress RemoveAddress(Ipv6Address address);
 
     /**
-     * \brief Update state of an interface address.
-     * \param address IPv6 address
-     * \param state new state
+     * @brief Update state of an interface address.
+     * @param address IPv6 address
+     * @param state new state
      */
     void SetState(Ipv6Address address, Ipv6InterfaceAddress::State_e state);
 
     /**
-     * \brief Update NS DAD packet UID of an interface address.
-     * \param address IPv6 address
-     * \param uid packet UID
+     * @brief Update NS DAD packet UID of an interface address.
+     * @param address IPv6 address
+     * @param uid packet UID
      */
     void SetNsDadUid(Ipv6Address address, uint32_t uid);
 
     /**
-     * \return NDISC cache used by this interface
+     * @return NDISC cache used by this interface
      */
     Ptr<NdiscCache> GetNdiscCache() const;
 
@@ -270,7 +270,7 @@
      * auto-generated Ndisc cache and it allow the neighbor cache helper to update
      * neighbor's Ndisc cache
      *
-     * \param removeAddressCallback Callback when remove an address.
+     * @param removeAddressCallback Callback when remove an address.
      */
     void RemoveAddressCallback(
         Callback<void, Ptr<Ipv6Interface>, Ipv6InterfaceAddress> removeAddressCallback);
@@ -280,103 +280,103 @@
      * auto-generated Ndisc cache and it allow the neighbor cache helper to update
      * neighbor's Ndisc cache
      *
-     * \param addAddressCallback Callback when remove an address.
+     * @param addAddressCallback Callback when remove an address.
      */
     void AddAddressCallback(
         Callback<void, Ptr<Ipv6Interface>, Ipv6InterfaceAddress> addAddressCallback);
 
   protected:
     /**
-     * \brief Dispose this object.
+     * @brief Dispose this object.
      */
     void DoDispose() override;
 
   private:
     /**
-     * \brief Container for the Ipv6InterfaceAddresses.
+     * @brief Container for the Ipv6InterfaceAddresses.
      */
     typedef std::list<std::pair<Ipv6InterfaceAddress, Ipv6Address>> Ipv6InterfaceAddressList;
 
     /**
-     * \brief Container Iterator for the Ipv6InterfaceAddresses.
+     * @brief Container Iterator for the Ipv6InterfaceAddresses.
      */
     typedef std::list<std::pair<Ipv6InterfaceAddress, Ipv6Address>>::iterator
         Ipv6InterfaceAddressListI;
 
     /**
-     * \brief Const Container Iterator for the Ipv6InterfaceAddresses.
+     * @brief Const Container Iterator for the Ipv6InterfaceAddresses.
      */
     typedef std::list<std::pair<Ipv6InterfaceAddress, Ipv6Address>>::const_iterator
         Ipv6InterfaceAddressListCI;
 
     /**
-     * \brief Initialize interface.
+     * @brief Initialize interface.
      */
     void DoSetup();
 
     /**
-     * \brief The addresses assigned to this interface.
+     * @brief The addresses assigned to this interface.
      */
     Ipv6InterfaceAddressList m_addresses;
 
     /**
-     * \brief The link-local addresses assigned to this interface.
+     * @brief The link-local addresses assigned to this interface.
      */
     Ipv6InterfaceAddress m_linkLocalAddress;
 
     /**
-     * \brief The state of this interface.
+     * @brief The state of this interface.
      */
     bool m_ifup;
 
     /**
-     * \brief Forwarding state.
+     * @brief Forwarding state.
      */
     bool m_forwarding;
 
     /**
-     * \brief The metric.
+     * @brief The metric.
      */
     uint16_t m_metric;
 
     /**
-     * \brief Node associated with this interface.
+     * @brief Node associated with this interface.
      */
     Ptr<Node> m_node;
 
     /**
-     * \brief NetDevice associated with this interface.
+     * @brief NetDevice associated with this interface.
      */
     Ptr<NetDevice> m_device;
 
     /**
-     * \brief TrafficControlLayer associated with this interface.
+     * @brief TrafficControlLayer associated with this interface.
      */
     Ptr<TrafficControlLayer> m_tc;
 
     /**
-     * \brief Neighbor cache.
+     * @brief Neighbor cache.
      */
     Ptr<NdiscCache> m_ndCache;
 
     /**
-     * \brief Current hop limit.
+     * @brief Current hop limit.
      */
     uint8_t m_curHopLimit;
 
     /**
-     * \brief Base value used for computing the random reachable time value (in millisecond).
+     * @brief Base value used for computing the random reachable time value (in millisecond).
      */
     uint16_t m_baseReachableTime;
 
     /**
-     * \brief Reachable time (in millisecond).
+     * @brief Reachable time (in millisecond).
      * The time a neighbor is considered reachable after receiving a reachability confirmation.
      */
     uint16_t m_reachableTime;
 
     /**
-     * \brief Retransmission timer (in millisecond).
+     * @brief Retransmission timer (in millisecond).
      * Time between retransmission of NS.
      */
     uint16_t m_retransTimer;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/internet/model/ipv6-l3-protocol.cc ns-3.44/src/internet/model/ipv6-l3-protocol.cc
--- ns-3.43/src/internet/model/ipv6-l3-protocol.cc	2024-10-09 16:41:09.888656000 -0700
+++ ns-3.44/src/internet/model/ipv6-l3-protocol.cc	2025-03-09 16:55:49.399371100 -0700
@@ -44,8 +44,6 @@
 
 NS_OBJECT_ENSURE_REGISTERED(Ipv6L3Protocol);
 
-const uint16_t Ipv6L3Protocol::PROT_NUMBER = 0x86DD;
-
 TypeId
 Ipv6L3Protocol::GetTypeId()
 {
@@ -1320,7 +1318,6 @@
     // Forwarding
     Ipv6Header ipHeader = header;
     Ptr<Packet> packet = p->Copy();
-    ipHeader.SetHopLimit(ipHeader.GetHopLimit() - 1);
 
     if (ipHeader.GetSource().IsLinkLocal())
     {
@@ -1328,7 +1325,9 @@
         return;
     }
 
-    if (ipHeader.GetHopLimit() == 0)
+    // RFC 8200: When forwarding, the packet is discarded if Hop
+    // Limit was zero when received or is decremented to zero.
+    if (ipHeader.GetHopLimit() <= 1)
     {
         NS_LOG_WARN("TTL exceeded.  Drop.");
         m_dropTrace(ipHeader, packet, DROP_TTL_EXPIRED, this, 0);
@@ -1342,6 +1341,7 @@
         }
         return;
     }
+    ipHeader.SetHopLimit(ipHeader.GetHopLimit() - 1);
 
     /* ICMPv6 Redirect */
 
